-- This project is based on an example from Stuart Padley's Weblog 
-- subtitled "SQL Server 2005 stuff I couldn't find anywhere else"
-- http://blogs.msdn.com/stuartpa/archive/2005/07/25/443229.aspx

-- This script permits sending multiple messages without
-- Dropping and recreating the database objects.

USE Initiator;
GO

EXEC SendMessageProc;
GO

-- STAGE 5: Make sure your message got there
USE Target;
GO

SELECT CONVERT( nvarchar(max), message_body ) AS TargetMessage FROM TargetQueue
-- SELECT * FROM TargetQueue
GO

WHILE (1 = 1)
BEGIN 
   DECLARE @conversation_handle UNIQUEIDENTIFIER,
           @conversation_group_id UNIQUEIDENTIFIER,
           @message_body NVARCHAR(max),
           @message_type_name NVARCHAR(128);
   BEGIN TRANSACTION;
   WAITFOR(GET CONVERSATION GROUP @conversation_group_id FROM TargetQueue),
      TIMEOUT 500;
   IF @conversation_group_id IS NULL
   BEGIN
      ROLLBACK TRANSACTION;
      BREAK;
   END;
   WHILE (1 = 1)
   BEGIN
      RECEIVE TOP(1)
         @conversation_handle = conversation_handle,
         @message_type_name = message_type_name,
         @message_body = CAST(message_body AS NVARCHAR(max))
      FROM TargetQueue
      WHERE conversation_group_id = @conversation_group_id;

      IF @@ROWCOUNT = 0 OR @@ERROR <> 0 BREAK;

      SELECT 'Conversation Group Id' = @conversation_group_id,
             'Conversation Handle' = @conversation_handle,
             'Message Type Name' = @message_type_name,
             'Message Body' = @message_body;
      IF @message_type_name = 'http://schemas.microsoft.com/SQL/ServiceBroker/EndDialog'
         OR @message_type_name = 'http://schemas.microsoft.com/SQL/ServiceBroker/Error'
      BEGIN
         END CONVERSATION @conversation_handle;
      END;
   END;
   COMMIT TRANSACTION;
END;
GO

USE master;
GO