-- These settings enable Service Broker and Query Notifications in Northwind
USE Northwind;
-- Set compatibility level to SQL Server 2005
EXECUTE sp_dbcmptlevel 'Northwind',90;
-- Enable Service Broker and mark database trustworthy
IF NOT EXISTS (SELECT * FROM sys.databases
   WHERE name = 'Northwind' AND is_broker_enabled = 1)
BEGIN
   ALTER DATABASE Northwind SET ENABLE_BROKER 
      WITH ROLLBACK AFTER 5 SECONDS;
   ALTER DATABASE Northwind SET TRUSTWORTHY ON;
END;
GO
-- Add 
-- SELECT * FROM sys.symmetric_keys;
IF NOT EXISTS 
    (SELECT * FROM sys.symmetric_keys WHERE symmetric_key_id = 101)
CREATE MASTER KEY ENCRYPTION BY PASSWORD = N'23987hxJ#KL95234nl0zBe';
--The password is from the CREATE MASTER KEY help topic with N' added.
GO
SET ANSI_NULLS ON;
SET ANSI_PADDING ON;
SET ANSI_WARNINGS ON; 
SET CONCAT_NULL_YIELDS_NULL ON; 
SET QUOTED_IDENTIFIER ON;
SET NUMERIC_ROUNDABORT OFF; 
SET ARITHABORT ON;
GO
