-- sb_users ROLE permissions for initiator and target
-- create the objects identified below before running this script
USE Northwind;
CREATE ROLE sb_users;
GO
GRANT VIEW DEFINITION TO sb_users;
GRANT SELECT TO sb_users;
GRANT EXECUTE TO sb_users;
GRANT REFERENCES ON MESSAGE TYPE :: NwindXmlMessage TO sb_users;
GRANT REFERENCES ON CONTRACT :: NwindContract TO sb_users;
GRANT RECEIVE ON NwindTargetQueue TO sb_users;
GRANT REFERENCES ON NwindTargetQueue TO sb_users;
GRANT SEND ON SERVICE :: NwindInitiatorService TO sb_users;

-- Create logins and users and assign to roles
EXEC sp_addrolemember 'sb_users', 'sbcreator';
CREATE LOGIN sbuser WITH PASSWORD = N'user', 
	DEFAULT_DATABASE = Northwind, CHECK_EXPIRATION = OFF, CHECK_POLICY = OFF;
GO
CREATE USER sbuser;
GO
EXEC sp_addrolemember 'sb_users', 'sbuser';
GO
USE master;
GO

